//
//  CSJLabelPrinter.h
//  CSJTSOLib_iOS
//
//  Created by Citizen on 2017/12/01.
//  Copyright 2017 Citizen. All rights reserved.
//
#import <Foundation/Foundation.h>
#import "CSJLabelDesign.h"


@interface CSJLabelPrinter : NSObject
{
}

- (int) connect:(int)connectType withAddrress:(NSString*)addr;
- (int) connect:(int)connectType withAddrress:(NSString*)addr withPort:(int)port;
- (int) connect:(int)connectType withAddrress:(NSString*)addr withPort:(int)port withTimeout:(int)timeout;
- (int) disconnect;

- (int) getVersionCode;
- (NSString *) getVersionName;

+ (NSArray *)searchCitizenPrinter:(int)ifType withSearchTime:(int)searchTime result:(int *)result;
+ (NSArray *)searchLabelPrinter:(int)ifType withSearchTime:(int)searchTime result:(int *)result;

- (int) sendData:(unsigned char*)data withLength:(unsigned long)length;

- (int) printerCheck;

- (int) print:(CSJLabelDesign*)design quantity:(int)quantity;

- (int) storeNVBitmap:(NSString*)filePath name:(NSString*)name rotation:(int)rotation width:(int)width height:(int)height;

- (int) clearOutput;


- (int) setHorizontalMagnification:(int)horizontalMagnification;
- (int) getHorizontalMagnification;

- (int) setVerticalMagnification:(int)verticalMagnification;
- (int) getVerticalMagnification;

- (int) setFormatAttribute:(int)formatAttribute;
- (int) getFormatAttribute;

- (int) setContinuousMediaLength:(int)continuousMediaLength;
- (int) getContinuousMediaLength;

- (int) setMeasurementUnit:(int)measurementUnit;
- (int) getMeasurementUnit;

- (int) setPrintSpeed:(int)printSpeed;
- (int) getPrintSpeed;

- (int) setFeedSpeed:(int)feedSpeed;
- (int) getFeedSpeed;

- (int) setSlewSpeed:(int)slewSpeed;
- (int) getSlewSpeed;

- (int) setBackupSpeed:(int)backupSpeed;
- (int) getBackupSpeed;

- (int) setPrintDarkness:(int)printDarkness;
- (int) getPrintDarkness;

- (int) setDoubleHeat:(int)doubleHeat;
- (int) getDoubleHeat;

- (int) setVerticalOffset:(int)verticalOffset;
- (int) getVerticalOffset;

- (int) setHorizontalOffset:(int)horizontalOffset;
- (int) getHorizontalOffset;

- (int) setMediaHandling:(int)mediaHandling;
- (int) getMediaHandling;

- (int) setStartOffset:(int)startOffset;
- (int) getStartOffset;

- (int) setStopOffset:(int)stopOffset;
- (int) getStopOffset;

- (int) setLabelSensor:(int)labelSensor;
- (int) getLabelSensor;

- (int) setPrintMethod:(int)printMethod;
- (int) getPrintMethod;

- (int) setSensorLocation:(int)sensorLocation;
- (int) getSensorLocation;

- (int) getCommandInterpreterInAction;
- (int) getPaperError;
- (int) getRibbonEnd;
- (int) getBatchProcessing;
- (int) getPrinting;
- (int) getPause;
- (int) getWaitingForPeeling;

- (void) setLog:(int)mode withPath:(NSString*)path withMaxSize:(int)maxSize;

// for Bonjour ......................................
//#ifdef V104_SUPPORT_BONJOUR
+ (BOOL) isMoveBonjour_IF1_ES01;
- (BOOL) isMoveBonjour_IF1_ES01;
+ (void) setMoveBonjour_IF1_ES01:(BOOL)mode;
- (void) setMoveBonjour_IF1_ES01:(BOOL)mode;
//#endif
// ..................................................

@end

@interface CitizenPrinterInfo : NSObject

-(id)initWithIPAddr:(NSString*)ipAddr withMACAddr:(NSString*)macAddr withDevName:(NSString*)devName withBDAddr:(NSString*)bdAddr;
-(id)initWithIPAddr:(NSString*)ipAddr withMACAddr:(NSString*)macAddr withDevName:(NSString*)devName withBDAddr:(NSString*)bdAddr withUSBSerialNo:(NSString*)serialNo;

@property (nonatomic, copy, readonly) NSString *ipAddress;
@property (nonatomic, copy, readonly) NSString *macAddress;
@property (nonatomic, copy, readonly) NSString *deviceName;
@property (nonatomic, copy, readonly) NSString *bdAddress;
@property (nonatomic, copy, readonly) NSString *usbSerialNo;

@end

